import tkinter

from tkinter import messagebox
import customtkinter
from PIL import Image
from encoding import useKey, EncodeFile, VerifyFile, UsePub
from os import getcwd
from os.path import basename
import socket
from client import sendFile, recieveFile, ServerMeet
from hashlib import sha256
#параметры
host = 'localhost'
port = 1234
buff_size = 1024


class Regist(customtkinter.CTk):
    def __init__(self):
        super().__init__()
        self.salt = 'salt'
        self.logd = 0
        self.con = 0
        self.cur_dir = getcwd()
        self.resizable(1, 1)

        self.client = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.try_connect()
        
        self.geometry('450x400+700+200')
        self.title('Login page')

        self.frame1 = customtkinter.CTkFrame(self, width=600)
        self.frame1.grid(row=0, column=0, padx=20, pady=20)

        self.l1 = customtkinter.CTkLabel(master=self.frame1, text="Начнём работу!", font=('Century Gothic', 15))
        self.l1.grid(row=0, column=0, padx=10)

        self.login = customtkinter.CTkEntry(master=self.frame1,
                                       placeholder_text="Логин",
                                       width=120,
                                       height=25,
                                       border_width=2,
                                       corner_radius=10, )
        self.login.grid(row=1, column=0)

        self.password = customtkinter.CTkEntry(master=self.frame1,
                                          placeholder_text="Пароль",
                                          width=120,
                                          height=25,
                                          border_width=2,
                                          corner_radius=10, show = '*')
        self.password.grid(row=2, column=0, pady=10)

        self.button1 = customtkinter.CTkButton(master=self.frame1, text='Войти',  fg_color='#C57A44', cursor='hand2', width = 20, command=self.login_button)
        self.button1.grid(row=3, column=0, pady=10)

        self.button2 = customtkinter.CTkButton(master=self.frame1,  fg_color='#C57A44', text='Зарегистрироваться', cursor='hand2',
                                          command=self.register_page)
        self.button2.grid(row=4, column=0, padx=10, pady=10)

        self.columnconfigure(0, weight=1)
        self.rowconfigure(0, weight=1)

        self.frame1.rowconfigure(0, weight=1)
        self.frame1.columnconfigure(0, weight=1)
   
    

    def login_button(self):
        global login, pas
        salted_pas = sha256((self.password.get() + self.salt).encode()).hexdigest()
        if self.con == 0:
            self.try_connect()
            if self.con == 0:
                messagebox.showerror('Ошибка', 'Нет подключения!')
                #print(f"Can't connect to: {host, port}")
                return

        res = (ServerMeet(self.client, f'login {self.login.get()} {salted_pas}'))
        if self.login.get() == '' or self.password.get() == '':
            messagebox.showerror('Ошибка', 'Не все поля заполнены')
        elif res == 'None':
            messagebox.showerror('Ошибка', 'Неверный логин или пароль')
        else:
            messagebox.showinfo('Добро пожаловать', 'Выполняется вход')
            self.logd = 1
            self.destroy()
            ServerMeet(self.client, f'exit')    
    def __del__(self):
        try:
            ServerMeet(self.client, f'exit')
            self.destroy()
        except:
            pass
    

    def register_page(self):
        self.frame1.grid_remove()
        self.frame2 = customtkinter.CTkFrame(self, corner_radius=10)
        self.frame2.grid(row=0, column=0, padx=20, pady=20)

        self.l1 = customtkinter.CTkLabel(master=self.frame2, text="Регистрация в системе  ", font=('Century Gothic', 15))
        self.l1.grid(row=0, column=0, sticky='e', padx=20, pady=10)

        self.first_name2 = customtkinter.CTkEntry(master=self.frame2,
                                            placeholder_text="Имя",
                                            width=120,
                                            height=25,
                                            border_width=2,
                                            corner_radius=10, )
        self.first_name2.grid(row=1, column=0, padx=5, pady=10)
        self.last_name2 = customtkinter.CTkEntry(master=self.frame2,
                                           placeholder_text="Фамилия",
                                           width=120,
                                           height=25,
                                           border_width=2,
                                           corner_radius=10, )
        self.last_name2.grid(row=2, column=0, padx=5, pady=10)

        self.login2 = customtkinter.CTkEntry(master=self.frame2,
                                       placeholder_text="Логин",
                                       width=120,
                                       height=25,
                                       border_width=2,
                                       corner_radius=10, )
        self.login2.grid(row=3, column=0, padx=5, pady=10)

        self.password2 = customtkinter.CTkEntry(master=self.frame2,
                                          placeholder_text="Пароль",
                                          width=120,
                                          height=25,
                                          border_width=2,
                                          corner_radius=10, show = '*')
        self.password2.grid(row=4, column=0, padx=5, pady=10)

        self.button5 = customtkinter.CTkButton(master=self.frame2, text='Зарегистрироваться', fg_color='#C57A44', cursor='hand2',
                                          command=self.register_button)
        self.button5.grid(row=5, column=0, pady=10)

        self.arleadyaccount = customtkinter.CTkLabel(master=self.frame2, text='Уже есть аккаунт?')
        self.arleadyaccount.grid(row=6, column=0)

        self.loginButton = customtkinter.CTkButton(master=self.frame2, text='Войти', fg_color='#C57A44', command=self.login_page)
        self.loginButton.grid(row=7, column=0, pady=10)

        self.columnconfigure(0, weight=1)
        self.rowconfigure(0, weight=1)

        self.frame2.rowconfigure(0, weight=1)
        self.frame2.columnconfigure(0, weight=1)
    def login_page(self):
        self.frame2.grid_remove()
        self.frame1.grid(row=0, column=0, padx=20, pady=20)
    def register_button(self):
        if self.con == 0:
            self.try_connect()
            if self.con == 0:
                messagebox.showerror('Ошибка', 'Нет подключения!')
                return

        if self.login2.get() == '' or self.password2.get() == '':
            messagebox.showerror('Ошибка', 'Не все поля заполнены')

        elif ServerMeet(self.client, f'log_unique {self.login2.get()}') != 'None':
            messagebox.showerror('Ошибка', 'Такой логин уже существует')
        else:
            salted_pas = sha256((self.password2.get() + self.salt).encode()).hexdigest()
            res = ServerMeet(self.client, f'reg {self.login2.get()} {self.first_name2.get()} {self.last_name2.get()} {salted_pas}')
            if res == 'ex_1':
                messagebox.showerror('Ошибка', 'Повторите попытку')
            else:
                messagebox.showinfo('Успех', 'Регистрация прошла успешно')

            self.frame2.grid_remove()
            self.frame1.grid(row=0, column=0, padx=20, pady=20)
    def try_connect(self):
        try:
            self.client.connect((host, port))
            self.con = 1
        except:
            pass



# if __name__ == '__main__':
#     app = Regist()
#     app.mainloop()
