import socket 
import threading
from time import sleep
from encoding import EncodeFile, VerifyFile, encrypt_str, decrypt_str
from ecdsa import SigningKey, VerifyingKey
from os import getcwd, mkdir
from os.path import join
import yadisk
from base_api import *
from random import randint

#Параметры
host = 'localhost'#
port = 1234
#Токен yandex диска
y = yadisk.YaDisk(token='<YOUR TOKEN>')
storage_dir = getcwd()

buff_size = 1024
private_key, public_key = None, None
name = None
users_now = 0

def recieveFile(client, file_name):
    try:
        file = open(join(storage_dir, name, file_name), 'wb')
    except:
        #print(f'[SERVER] can"t open {join(storage_dir, login,file_name)}')
        return
    data = client.recv(buff_size)
    while data[-5:] != b'<END>':
        file.write(data)
        data = client.recv(buff_size)
    
    if(len(data) > 5):
        file.write(data[0:-5])
        

    print("[SERVER]  transfered succesfully")
    
    file.close()
    

def sendFile(socket_, file_name):
    #socket_.send(file_name.encode())
    #print(file_name)
    try:
        file = open(file_name, 'rb')
    except:
        print(f'Cant open: {file_name}')
    data = file.read(buff_size)
    while data:
        socket_.send((data))
        data = file.read(buff_size)
    socket_.send(b'<END>')  
    print('[SERVER] msg shared!')

def sendFile_(socket_, file_name):
    file = open(file_name, 'rb')
    data = file.read()
    while data:
        socket_.send((data))
        data = file.read(buff_size)
    socket_.send(b'<END>')  
    print('[SERVER] msg shared!')

#
def uploadDisk(file_name):
    y.upload(join(storage_dir, name, file_name), f'test/{name}/{file_name}')



def recieveData(client):
    global name, private_key, public_key, users_now, union_key
    while True:
        try:
            command = client.recv(buff_size).decode()
            cmd_ = command[0:command.find(' ')]
            print(f'[SERVER] rec command from [{name}]: {command}')
            if cmd_ == 'send_file': # file: client -> server
                recieveFile(client, command[command.find(' ')+1:])
            elif cmd_ == 'use_key': #use_file <path>
                f = client.recv(buff_size)
                private_key = SigningKey.from_pem(f)
            elif cmd_ == 'use_key_pub':
                f = client.recv(buff_size)
                #print(f)
                public_key = VerifyingKey.from_pem(f)
            elif cmd_ == 'encode_file':#encode_file <path>
                EncodeFile(join(storage_dir, name, command[command.find(' ')+1:]).replace('\\', '/'), private_key)
                print(join(storage_dir, name, command[command.find(' ')+1:]).replace('\\', '/'))
                sendFile_(client, join(storage_dir, name, command[command.find(' ')+1:]+'.sig').replace('\\', '/'))
                pub_ = private_key.verifying_key
                #print(pub_.to_pem())
                sleep(1)
                client.send(pub_.to_pem())
                
            elif cmd_ == 'verify_sign':#verify_sign <source file> <signed file>
                args = command[command.find(' ')+1:] 
                res = (VerifyFile(join(storage_dir, name, args[0:args.find('.sig ')+4]), join(storage_dir, name, args[args.find('.sig ')+5:]), public_key))
                print(str(res))
                client.send(str(res).encode())
            elif cmd_ == 'send_encode_file':
                recieveFile(client, command[command.find(' ')+1:])
                EncodeFile(command[command.find(' ')+1:], private_key)

            elif cmd_ == 'send_encode_file_with_key':
                recieveFile(client, command[command.find(' ')+1:])
                f = client.recv(buff_size)
                private_key = SigningKey.from_pem(f)
                verify_key = private_key.verifying_key
                print('Here')
                EncodeFile(command[command.find(' ')+1:], private_key)
                client.send((command[command.find(' ')+1:]+".sig").encode())
                sendFile(client, command[command.find(' ')+1:]+'.sig')
                print(f'[SERVER] file {command[command.find(" ")+1:]} signed and sended back')

            elif cmd_ == 'rec_file_cloud':
                file_name = command[command.find(' ')+1:]
                y.download(f'/test/{name}/{file_name}', join(storage_dir, name, file_name))
                sendFile(client, join(storage_dir, name, file_name))
            elif cmd_ == 'reg':
                try:
                    s = command.split(' ')
                    try:
                        insert_into_users(s[1], s[2], s[3], s[4])
                        client.send((str('norm')).encode())
                    except:
                        client.send((str('ex_1')).encode())
                        continue
                    name = s[1]
                    mkdir(join(storage_dir, s[1]))
                    y.mkdir(f'/test/{name}')
                    print(f"[SERVER] Reg'd user: {s[1]}")
                except:
                    print(f"[SERVER] User already exist: {s[1]}")
            elif cmd_ == 'login':
                s = command.split(' ')
                name = s[1]
                print(f'[SERVER] Entered in app: {name}')
                res = user_verification(s[1],s[2])
                client.send((str(res)).encode())

            elif cmd_ == 'log_unique': 
                s = command.split(' ')
                res = checking_uniqueness(s[1])
                client.send((str(res)).encode())
                #print(name)
            elif cmd_ == 'upload_file':
                recieveFile(client, command[command.find(' ')+1:])
                uploadDisk(command[command.find(' ')+1:])
            
            elif command == 'dwnld_files':
                files = '|'.join([(x['name']+' <SIZE>'+ '%.2f' % (x['size']/1024)) for x in (y.listdir(f'/test/{name}')) ])
             
                print(files)
                if files == '':
                    files = ' '
                client.send(files.encode())
                print(f'[SERVER] files in disk shared for {name}')
            elif command == 'exit':
                print(f'[SERVER] client [ {name} ] disconnected')
                users_now -=1
                client.close()
                break
            else:
                print('[SERVER] Unknown command')
        except:
            pass
        
            

            


socket_ = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
socket_.bind((host, port))
socket_.listen(16)
print(f"[Server listening...]")
#print(getcwd())

def recieve():
    global users_now
    while True:
        try:
            conn, addr = socket_.accept()
            users_now += 1
        #регает новые подключения
            print(f"[New connection]: {addr}")
            print(f'[SERVER] active users {users_now}')
            #print(f'Current connections: {connections}')
            #sendFile(socket_, '1.png')
            thread = threading.Thread(target=recieveData, args=(conn,))
            thread.start()
        except:
            print("Can't connect")
        '''
        file_name = conn.recv(buff_size).decode()
        print(file_name)

        file = open(file_name, 'wb')

        data = conn.recv(buff_size)
        while data:
            file.write(data)
            data = conn.recv(buff_size)

        print("[SERVER]  transfered succesfully")
        '''
        
    


    conn.close()


recieve()
socket_.close()