import tkinter as tk
import customtkinter as ctk
from PIL import Image
from encoding import useKey, EncodeFile, VerifyFile, UsePub
from os import getcwd
from os.path import basename, getsize
import socket
from client import sendFile, recieveFile, ServerMeet
from gui_auth import *
from time import sleep
from random import randint
from tkinter import messagebox

#Параметры
host = 'localhost'
port = 1234
buff_size = 1024


class App(ctk.CTk):
    def __init__(self):
        super().__init__()



        self.cur_dir = getcwd()

        self.resizable(1,1)
        
        self.private_key = None
        self.public_key = None

        self.encode_file_path = None
        
        self.verify_file_path = None
        self.source_file_path =  None

        self.client = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        try:
            self.client.connect((host, port))
        except:
           print(f"Can't connect to: {host, port}")
       # recieveFile(self.client, 'ar.png')

        #self.client.send('login ilya'.encode())
        self.geometry('900x600+290+115')
        self.title('signify')
        self.list_dwnld_files = (ServerMeet(self.client, 'dwnld_files'))
        

        #set grid 1 row, 2 columns
        self.grid_rowconfigure(0, weight=1)
        self.grid_columnconfigure(1, weight=1)
        #self.grid_columnconfigure(2, weight=1)
        self.columnconfigure(0, minsize=230)
        self.columnconfigure(1, weight=1, minsize=700)
        #self.rowconfigure(0, minsize=600)
        
        #load images
        logo_image = ctk.CTkImage(Image.open('images/armadillo (1).png'), size = (60, 60)) 
        add_image = ctk.CTkImage(Image.open('images/cloud.png'), size = (30, 30))
        #folder_image = ctk.CTkImage(Image.open('folder.png'), size = (30, 30))
        encode_image = ctk.CTkImage(Image.open('images/key.png'), size = (30, 30))
        verify_image = ctk.CTkImage(Image.open('images/verify.png'), size = (30, 30))
        download_image = ctk.CTkImage(Image.open('images/download.png'), size = (30, 30))
        self.lablekey_image = ctk.CTkImage(Image.open('images/key2.png'), size = (400, 400))
        self.lablecloud_image = ctk.CTkImage(Image.open('images/cloud.png'), size = (400, 400))
        self.lableverify_image1 = ctk.CTkImage(Image.open('images/cross.png'), size = (400, 400))
        self.lableverify_image2 = ctk.CTkImage(Image.open('images/verify.png'), size = (400, 400))
        self.table_image = ctk.CTkImage(Image.open('images/table.png'), size = (512, 512))
        self.micro_load = ctk.CTkImage(Image.open('images/download.png'), size = (20, 20))
        
        #frame
        self.navigation_frame = ctk.CTkFrame(self, corner_radius=0, width=400)
        self.navigation_frame.grid(row=0, column=0, sticky='nsew', padx=10, pady=10)
       # self.navigation_frame.grid_rowconfigure(2, weight=1)
       
        #lable
        self.lable_logo = ctk.CTkLabel(self.navigation_frame, corner_radius=0, image=logo_image, font=ctk.CTkFont(size=20, weight="bold"), compound='left', text='signify      ')
        self.lable_logo.grid(row=0, column = 0, padx = 20, pady = 15)
        
        
        #buttons        
        self.add_button = ctk.CTkButton(self.navigation_frame, text=' Загрузить', image=add_image, compound='top', height=40, fg_color='#C57A44', command=self.upload_cloud, font=('Century Gothic', 15))
        self.add_button.grid(row=1, column = 0, sticky = 'nsew', padx=10, pady=5)

        self.download_button = ctk.CTkButton(self.navigation_frame, text=' Скачать', image=download_image, compound='top', height=40, fg_color='#C57A44', command=self.download_cloud, font=('Century Gothic', 15))
        self.download_button.grid(row=2, column = 0, sticky = 'nsew', padx=10, pady=5)

        self.verify = ctk.CTkButton(self.navigation_frame, text=' Проверка подписи', image=verify_image, compound='top', height=40, fg_color='#C57A44', command=self.verify_main, font=('Century Gothic', 15))
        self.verify.grid(row=3, column = 0, sticky = 'ew', padx=10, pady=5)

        self.encode = ctk.CTkButton(self.navigation_frame, text=' Подписать', image=encode_image, compound='top', height=40, command=self.encode_main, fg_color='#C57A44', font=('Century Gothic', 15))
        self.encode.grid(row=4, column = 0, sticky = 'ew',padx=10, pady=5)
        

        #main frame
        self.main_frame = ctk.CTkFrame(self, corner_radius=0)
      #  self.main_frame.grid_columnconfigure(0, weight=1)
        self.main_frame.grid(row=0, column=1, padx=10, pady = 10, sticky = 'nsew')
        
        self.main_frame.rowconfigure(0, weight=1)
        self.main_frame.rowconfigure(1, weight=1)
        self.main_frame.rowconfigure(2, weight=1)
        self.main_frame.rowconfigure(3, weight=1)
        self.main_frame.rowconfigure(4, weight=1)
        self.main_frame.columnconfigure(1, weight=1)
        
        
        self.label = ctk.CTkLabel(self.main_frame, corner_radius=0, image=self.table_image, font=ctk.CTkFont(size=20, weight="bold"), compound='left', text='')
        self.label.grid(row=0,column=1, padx=25, pady = 25)

        
        #buttons for verify page
       # self.button_verify = ctk.CTkButton(self.main_frame, )
    def __del__(self):
        ServerMeet(self.client, 'exit')

    def encode_main(self):
        for widget in self.main_frame.winfo_children():
            widget.destroy()


        #Label 
        self.label = ctk.CTkLabel(self.main_frame, corner_radius=0, text='Выберите файл и ключ для шифрования:', 
                                  image=self.lablekey_image, compound='top', anchor=ctk.CENTER,font=ctk.CTkFont(size=18, weight="bold"))
        self.label.grid(row=0, column=1)
        
        
      
        #buttons for encode page
        self.button_file = ctk.CTkButton(self.main_frame, corner_radius=5, text = 'Закрытый ключ', fg_color='#C57A44', 
                                         command=lambda: self.pick_file(('Pem Files', '*.pem'), 'private_key'))
        self.privateKey_file = ctk.CTkButton(self.main_frame, corner_radius=5, text = 'Файл для подписи', fg_color='#C57A44', 
                                             command=lambda: self.pick_file(('All files', '*.*'), 'encode_file_path'))
        
        #self.sign_file = ctk.CTkButton(self.main_frame, corner_radius=5, text = 'Make sign', fg_color='#C57A44', command=lambda : EncodeFile(self.encode_file_path, self.private_key))
        self.sign_file = ctk.CTkButton(self.main_frame, corner_radius=5, text = 'Сделать подпись', fg_color='#C57A44', 
                                       command=lambda : self.ServerMeet_(self.client, f'encode_file'))
        
        
        self.button_file.grid(row=1, column = 1, sticky = 'nsew', padx=10, pady=5)
        self.privateKey_file.grid(row=2, column = 1, sticky = 'nsew', padx=10, pady=5)
        self.sign_file.grid(row=3, column=1, sticky = 'nsew', padx=10, pady=5)


   # def pick_and_send(self, name):
    #    if (name == "private_key"):

    def ServerMeet_(self, client, s):
       # if self.encode_file_path != None and self.private_key != None:
        if self.encode_file_path != None and self.private_key != None: 
            ServerMeet(self.client, f'encode_file {basename(self.encode_file_path)}')
            messagebox.showinfo('signify', 'Файл успешно подписан!')   
        else:
            messagebox.showerror('signify', 'Выберите закрытый ключ и файл подписи!')

        #else:
         #   messagebox.showerror('Ошибка', 'Выберите файл и закрытый ключ для подписи')


    def verify_main(self):
        for widget in self.main_frame.winfo_children():
            widget.destroy()
        
        self.label = ctk.CTkLabel(self.main_frame, corner_radius=0, text='Выберите подписанный файл, исходный файл и открытый ключ:', 
                                  image=self.lablekey_image, compound='top', anchor=ctk.CENTER,font=ctk.CTkFont(size=18, weight="bold"))
        self.label.grid(row=0, column=1)
        
        
        self.label.columnconfigure(1, weight=1)
        
        
        self.publicKey_file = ctk.CTkButton(self.main_frame, corner_radius=5, text = 'Открытый ключ', fg_color='#C57A44',
                                            command=lambda: self.pick_file(('Pem Files', '*.pem'), 'public_key'))
        self.signed_file = ctk.CTkButton(self.main_frame, corner_radius=5, text = 'Подписанный файл', fg_color='#C57A44', 
                                         command=lambda: self.pick_file(('All files', '*.*'), 'signed_file'))
        self.source_file = ctk.CTkButton(self.main_frame, corner_radius=5, text = 'Исходный файл', fg_color='#C57A44', 
                                         command=lambda: self.pick_file(('All files', '*.*'), 'source_file'))
        self.verify_file = ctk.CTkButton(self.main_frame, corner_radius=5, text = 'Проверка подписи', fg_color='#C57A44', 
                                         command=lambda : 
                            self.VerifyFile_(path_sig = self.verify_file_path, path_source=self.source_file_path))
        
        
        self.publicKey_file.grid(row=1, column = 1, sticky = 'nsew', padx=10, pady=5)
        self.signed_file.grid(row=2, column = 1, sticky = 'nsew', padx=10, pady=5)
        self.source_file.grid(row=3, column = 1, sticky = 'nsew', padx=10, pady=5)
        self.verify_file.grid(row=4, column=1, sticky = 'nsew', padx=10, pady=5)

        
    def VerifyFile_(self, path_sig, path_source):
        print('sig:',path_sig,  'source:',path_source)
        if path_sig == None and path_source == None:
            messagebox.showerror('signify', 'Выберите необходимые параметры')
            return
        res = ServerMeet(self.client, f"verify_sign {basename(path_sig)} {basename(path_source)}")
        #print(res, res == True)
        if res == 'True':
            self.label.configure(image = self.lableverify_image2)
            messagebox.showinfo('signify', 'Подпись документа достоверна')
        else:
            self.label.configure(image = self.lableverify_image1)
            messagebox.showinfo('signify', 'Подпись документа неверна')
            
    def upload_cloud(self):
        for widget in self.main_frame.winfo_children():
            widget.destroy()
        
        self.label = ctk.CTkLabel(self.main_frame, corner_radius=0, text='Выберите файл, чтобы загрузить его в облако:', 
                                  image=self.lablecloud_image, compound='top', anchor=ctk.CENTER,font=ctk.CTkFont(size=20, weight="bold"))
        self.label.grid(row=0, column=1)
        self.label.grid_rowconfigure(0, weight=1)
        self.label.grid_columnconfigure(1, weight=1)
        self.source_file2 = ctk.CTkButton(self.main_frame, corner_radius=5, text = 'Исходный файл', fg_color='#C57A44', 
                                         command=lambda: self.pick_file(('All files', '*.*'), 'upload_file'))
        self.source_file2.grid(row=1, column=1, sticky = 'nsew', padx=10, pady=5)
        


    def add_item(self, name, t):

        name_ = name[:name.find('<SIZE>')-1]
        size = name[name.find('<SIZE>')+6:]+' KB'
        if len(name_) > 35:
            name_ = name_[0:34]+'...'
        name_ = name_ + ', '+size
        label_left = ctk.CTkLabel(master=self.scroll_files, text = name_, anchor = 'w')
        button_right = ctk.CTkButton(master=self.scroll_files, corner_radius=5, text = 'скачать', image = self.micro_load, fg_color='#C57A44', compound = 'left', 
                                         anchor='w', command=lambda: self.dwnload_file(name[:name.find('<SIZE>')-1]))

        label_left.grid(row=t, column=0, sticky='w')
        button_right.grid(row=t, column=2, padx = 10, pady=5, sticky = 'nsew')

    def download_cloud(self):
        for widget in self.main_frame.winfo_children():
            widget.destroy()
        self.scroll_files = ctk.CTkScrollableFrame(master = self.main_frame, width=550, height=700)
        
        self.scroll_files.grid(row=0, column=1)
        self.scroll_files.grid_columnconfigure(1, weight=1)
        self.scroll_files.grid_columnconfigure(2, weight=1, minsize = 100)
        
        #self.scroll_files.grid_columnconfigure(1, weight=1)
        #self.scroll_files.grid_rowconfigure(0, weight=1)
        #self.scroll_files.grid_rowconfigure(1, weight=1)

        t = 0
        for item in self.list_dwnld_files:
            if item != ' ':
                self.add_item(item, t)
                t+= 1

    def dwnload_file(self, item):
        #print('Pressed button with item: ', item)
        ServerMeet(self.client, f'rec_file_cloud {item}')


         
    def pick_file(self, format, name):
        filepath = ctk.filedialog.askopenfilename(filetypes=[format])
        if filepath != '':
            if name == 'private_key':
                self.private_key = useKey(filepath)
                #self.client.send('use_key ')
                ServerMeet(self.client, f'use_key {(filepath)}')
                #self.public_key = self.private_key.verifying_key
                if self.private_key != None:
                    print('Readed key')
            elif name == 'public_key':
                self.public_key = UsePub(filepath)
                ServerMeet(self.client, f'use_key_pub {(filepath)}')

            elif name == 'encode_file_path':
                self.encode_file_path = filepath
                ServerMeet(self.client, f'send_file {filepath}')
                #self.SendFile_()

            elif name == 'signed_file':
                self.verify_file_path = filepath
                ServerMeet(self.client, f'send_file {filepath}')

            elif name == 'source_file':
                self.source_file_path = filepath
                ServerMeet(self.client, f'send_file {filepath}')
            elif name == 'upload_file':
                self.source_file = filepath
                size = getsize(filepath)
                
                self.list_dwnld_files.append(basename(filepath)+' <SIZE>'+'%.2f' % (size/1024) )
                ServerMeet(self.client, f'upload_file {filepath}')
                messagebox.showinfo('signify', 'Файл успешно доставлен')
        

        print(filepath)        

if __name__ == '__main__':    
    log = Regist()
    log.mainloop()
    ServerMeet(log.client, 'exit')
    if log.logd == 1:
        app = App()
        app.mainloop()
        ServerMeet(app.client, 'exit')




